/*
 * 2013/07/05 sample-001.c
 */

/*
 *  񕪖@
 *
 *	_lL[{[h͂A̕o͂
 *	iƂẮAu񕪖@vg
 *
 * p@
 *		RpC
 *			cc -Ic:\usr\c\include -o sample-001.exe sample-001.c
 *		s
 *			sample-001
 */

#include <stdio.h>
#include <stdlib.h>		/* exit 𗘗p̂ŕKv */

#include "s_input.h"
#include "s_print.h"

/*
 *
 */

#define	EPSILON	0.00000001		/* 덷 */

/*
 * double regula_falsi_square_root ( double a, double min, double mid, double max )
 *		double a	̌ɂȂ鐔(肵Ă)
 *		double min, max ̓Ԃ͈̔
 *		double mid	min  mid ̒_
 *		return		a 
 *			񕪖@ɂAa ̕߂
 *			0 < min < a ̕ < max
 */

double regula_falsi_square_root ( double a, double min, double mid, double max ) {

	if ( max - min < EPSILON ) {	/* \ɐx */
		return mid;					/* _̒l𓚂ƂĕԂ */
	} else {						/* ܂A߂Kv */
		/* min ̂ǂ瑤ɂ邩𒲂.. ɕċԂ𒲐 */
		/* f(x)=x^2-a */
		if ( mid * mid - a < 0.0 ) {	/* f(mid) ̕mF */
					/* ̍ɂ */
			return regula_falsi_square_root ( a, mid, (mid+max)/2.0, max );
		} else {	/* ̉Eɂ */
			return regula_falsi_square_root ( a, min, (min+mid)/2.0, mid );
		}
	}
}


/*
 * double square_root ( double a )
 *		double a	̌ɂȂ鐔
 *		return		a 
 *			a ̕߂ČʂƂĕԂA
 *			vZ̊{́Aregula_falsi_square_root ɂ܂
 *			ł́AvZ̐Ks
 */

double square_root ( double a ) {

	if ( a < 0.0 ) {					/* a ̐Ȃ.. */
		s_print_string ( "͌̕vZł܂\n" );
										/* G[bZ[Wo͂.. */
		exit ( -1 );					/* Error Code (-1) ŃvOI */
	} else if ( a < 1.0 ) {				/* a  1.0 ȉȂ */
		return regula_falsi_square_root ( a, a, (a+1.0)/2.0, 1.0 );
										/*  a  1.0 ̊Ԃɂ */
	} else {							/* łȂ.. */
		return regula_falsi_square_root ( a, 1.0, (1.0+a)/2.0, a );
										/*  1.0  a ̊Ԃɂ */
	}

}

/*
 * void print_square_root ( double a )
 *		double a	vZ鐔
 *			̐ƁAo͂
 */

void print_square_root ( double a ) {

	 s_print_double ( a );
	 s_print_string ( " ̕ " );
	 s_print_double ( square_root ( a ) );
	 s_print_string ( " łB\n" );

}

/*
 *	main
 */

int main( double argc, char *argv[] )
{

	s_print_string ( "l͂Ă : " );	
	print_square_root ( s_input_double() );

	return 0;
}
